Index: /orxonox/trunk/src/defs/debug.h
===================================================================
--- /orxonox/trunk/src/defs/debug.h	(revision 3589)
+++ /orxonox/trunk/src/defs/debug.h	(revision 3590)
@@ -22,4 +22,11 @@
 #define _DEBUG_H
 
+#if HAVE_CONFIG_H 
+#include <config.h> 
+#endif
+
+#include <stdio.h>
+
+// DEFINE ERROR MODES
 #define NO              0
 #define ERR             1
@@ -29,10 +36,21 @@
 #define vDEBUGING       5
 
-#if HAVE_CONFIG_H 
-#include <config.h> 
-#endif
-
-#include <stdio.h>
-
+#ifndef DEBUG_SPECIAL_MODULE
+extern int verbose;
+#else
+// DEFINE MODULES
+#define DEBUG_MODULE_WORLD              0
+#define DEBUG_MODULE_PNODE              0
+#define DEBUG_MODULE_TRACKMANAGER       0
+#define DEBUG_MODULE_LIGHT              0
+#define DEBUG_MODULE_WORLD_ENTITY       0
+#define DEBUG_MODULE_PLAYER             0
+#define DEBUG_MODULE_PNODE              0
+#define DEBUG_MODULE_IMPORTER           0
+#define DEBUG_MODULE_MATH               0
+
+#define verbose DEBUG_SPECIAL_MODULE
+
+#endif
 ///////////////////////////////////////////////////
 /// PRINTF: prints with filename and linenumber ///
@@ -40,5 +58,5 @@
 
 #ifdef DEBUG
-extern int verbose;
+
 #define PRINTF(x) \
            PRINTF ## x
@@ -97,5 +115,4 @@
 ///////////////////////////////////////////////////
 #ifdef  DEBUG
-extern int verbose;
 #define PRINT(x) \
   PRINT ## x
Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3590)
@@ -17,4 +17,6 @@
    \todo Smooth-Parent: delay, speed
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PNODE
 
 
Index: /orxonox/trunk/src/lib/graphics/importer/array.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/array.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/array.cc	(revision 3590)
@@ -13,4 +13,6 @@
    co-programmer: ...
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
 
 #include "array.h"
Index: /orxonox/trunk/src/lib/graphics/importer/array.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/array.h	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/array.h	(revision 3590)
@@ -8,6 +8,4 @@
 #ifndef _ARRAY_H
 #define _ARRAY_H
-
-extern int verbose; //!< will be obsolete soon
 
 #include "stdincl.h"
Index: /orxonox/trunk/src/lib/graphics/importer/material.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/material.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/material.cc	(revision 3590)
@@ -14,4 +14,6 @@
 
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
 
 #include "material.h"
Index: /orxonox/trunk/src/lib/graphics/importer/material.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/material.h	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/material.h	(revision 3590)
@@ -9,7 +9,4 @@
 #define _MATERIAL_H
 
-
-
-extern int verbose; //!< will be obsolete soon.
 
 #if HAVE_CONFIG_H 
Index: /orxonox/trunk/src/lib/graphics/importer/model.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/model.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/model.cc	(revision 3590)
@@ -13,4 +13,6 @@
    co-programmer: ...
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
 
 #include "model.h"
Index: /orxonox/trunk/src/lib/graphics/importer/objModel.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/objModel.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/objModel.cc	(revision 3590)
@@ -13,4 +13,6 @@
    co-programmer: ...
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
 
 #include "objModel.h"
Index: /orxonox/trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/texture.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/texture.cc	(revision 3590)
@@ -17,4 +17,6 @@
 */
 
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
 
 #include "texture.h"
Index: /orxonox/trunk/src/lib/graphics/importer/windowHandler.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/windowHandler.h	(revision 3589)
+++ /orxonox/trunk/src/lib/graphics/importer/windowHandler.h	(revision 3590)
@@ -7,6 +7,4 @@
 #ifndef _WINDOWHANDLER_H
 #define _WINDOWHANDLER_H
-
-extern int verbose;
 
 #include "stdincl.h"
Index: /orxonox/trunk/src/lib/gui/gui/orxonox_gui_gtk.h
===================================================================
--- /orxonox/trunk/src/lib/gui/gui/orxonox_gui_gtk.h	(revision 3589)
+++ /orxonox/trunk/src/lib/gui/gui/orxonox_gui_gtk.h	(revision 3590)
@@ -9,7 +9,4 @@
 #include <config.h> 
 #endif
-
-//! verbose level, soon obsolete
-extern int verbose; // soon obsolete here
 
 #include "debug.h"
Index: /orxonox/trunk/src/lib/math/vector.cc
===================================================================
--- /orxonox/trunk/src/lib/math/vector.cc	(revision 3589)
+++ /orxonox/trunk/src/lib/math/vector.cc	(revision 3590)
@@ -19,4 +19,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_MATH
 
 #include "vector.h"
Index: /orxonox/trunk/src/light.cc
===================================================================
--- /orxonox/trunk/src/light.cc	(revision 3589)
+++ /orxonox/trunk/src/light.cc	(revision 3590)
@@ -16,4 +16,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LIGHT
 
 #include "light.h"
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3589)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3590)
@@ -14,4 +14,6 @@
    co-programmer: Christian Meyer
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD
 
 #include "world.h"
Index: /orxonox/trunk/src/track_manager.cc
===================================================================
--- /orxonox/trunk/src/track_manager.cc	(revision 3589)
+++ /orxonox/trunk/src/track_manager.cc	(revision 3590)
@@ -14,4 +14,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_TRACKMANAGER
 
 #include "track_manager.h"
Index: /orxonox/trunk/src/world_entities/player.cc
===================================================================
--- /orxonox/trunk/src/world_entities/player.cc	(revision 3589)
+++ /orxonox/trunk/src/world_entities/player.cc	(revision 3590)
@@ -15,4 +15,6 @@
    co-programmer: Christian Meyer
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PLAYER
 
 #include "player.h"
Index: /orxonox/trunk/src/world_entities/primitive.cc
===================================================================
--- /orxonox/trunk/src/world_entities/primitive.cc	(revision 3589)
+++ /orxonox/trunk/src/world_entities/primitive.cc	(revision 3590)
@@ -41,5 +41,5 @@
   this->material->setDiffuseMap("../data/pictures/load_screen.jpg");
   this->material->setIllum(3);
-  this->material->setAmbient(1, 1, 1);
+  this->material->setSpecular(1, 1, 1);
 }
 
Index: /orxonox/trunk/src/world_entities/skysphere.cc
===================================================================
--- /orxonox/trunk/src/world_entities/skysphere.cc	(revision 3589)
+++ /orxonox/trunk/src/world_entities/skysphere.cc	(revision 3590)
@@ -24,4 +24,6 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
 #include "material.h"
 #include "skysphere.h"
@@ -29,5 +31,4 @@
 #include "vector.h"
 #include "world_entity.h"
-
 
 using namespace std;