Index: /orxonox/trunk/src/command_node.cc
===================================================================
--- /orxonox/trunk/src/command_node.cc	(revision 3590)
+++ /orxonox/trunk/src/command_node.cc	(revision 3591)
@@ -14,4 +14,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COMMAND_NODE
 
 #include "command_node.h"
@@ -112,5 +113,5 @@
   FILE* stream;
   
-  printf("Loading key bindings from %s\n", filename);
+  PRINTF(4)("Loading key bindings from %s\n", filename);
   
   if( filename == NULL) filename = DEFAULT_KEYBIND_FILE;
@@ -127,5 +128,5 @@
   if( parser.getSection ("Bindings") == -1)
     {
-      printf("Could not find key bindings in %s\n", filename);
+      PRINTF(1)("Could not find key bindings in %s\n", filename);
       return;
     }
@@ -145,9 +146,9 @@
 	{
 	case 0:
-	  printf("Key binding %d(%s) set to %s\n", index[1], SDLKToKeyname( index[1]), valuebuf);
+	  PRINTF(4)("Key binding %d(%s) set to %s\n", index[1], SDLKToKeyname( index[1]), valuebuf);
 	  strcpy (aliases->keys[index[1]], valuebuf);
 	  break;
 	case 1:
-	  printf("Button binding %d(%s) set to %s\n", index[1], SDLBToButtonname( index[1]), valuebuf);
+	  PRINTF(4)("Button binding %d(%s) set to %s\n", index[1], SDLBToButtonname( index[1]), valuebuf);
 	  strcpy (aliases->buttons[index[1]], valuebuf);
 	  break;
@@ -214,5 +215,5 @@
   while( SDL_PollEvent (&event))
     {
-      printf("CommandNode::processLocal() =========================got Event\n");
+      PRINTF(3)("CommandNode::processLocal() =========================got Event\n");
       memset (cmd.cmd, 0, CMD_LENGHT); 
       switch( event.type)
Index: /orxonox/trunk/src/defs/debug.h
===================================================================
--- /orxonox/trunk/src/defs/debug.h	(revision 3590)
+++ /orxonox/trunk/src/defs/debug.h	(revision 3591)
@@ -39,14 +39,18 @@
 extern int verbose;
 #else
-// DEFINE MODULES
+// DEFINE MODULES \\
+#define DEBUG_MODULE_ORXONOX            0
 #define DEBUG_MODULE_WORLD              0
 #define DEBUG_MODULE_PNODE              0
-#define DEBUG_MODULE_TRACKMANAGER       0
+#define DEBUG_MODULE_WORLD_ENTITY       0
+#define DEBUG_MODULE_COMMAND_NODE       0
+
+#define DEBUG_MODULE_IMPORTER           0
+#define DEBUG_MODULE_TRACK_MANAGER      0
 #define DEBUG_MODULE_LIGHT              0
-#define DEBUG_MODULE_WORLD_ENTITY       0
 #define DEBUG_MODULE_PLAYER             0
-#define DEBUG_MODULE_PNODE              0
-#define DEBUG_MODULE_IMPORTER           0
 #define DEBUG_MODULE_MATH               0
+
+#define DEBUG_MODULE_NULL_PARENT        0
 
 #define verbose DEBUG_SPECIAL_MODULE
Index: /orxonox/trunk/src/lib/coord/null_parent.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3590)
+++ /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3591)
@@ -16,4 +16,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_NULL_PARENT
 
 #include "null_parent.h"
@@ -38,5 +39,5 @@
 NullParent::NullParent () : PNode (new Vector(0,0,0), NULL)
 {
-  printf("NullParent::NullParent() - making new NullParent, there can only be one..\n");
+  PRINTF(4)("NullParent::NullParent() - making new NullParent, there can only be one..\n");
   this->parent = this;
   this->mode = PNODE_ALL;
@@ -76,5 +77,5 @@
 {
 
-  printf ("NullParent::update - (%f, %f, %f)\n", this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
+  PRINTF(4)("NullParent::update - (%f, %f, %f)\n", this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   this->absCoordinate = this->relCoordinate;
   this->absDirection = parent->getAbsDir () * this->relDirection;
Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3590)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3591)
@@ -19,5 +19,4 @@
 
 #define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PNODE
-
 
 #include "p_node.h"
@@ -413,5 +412,4 @@
   PRINTF(2)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   // printf("%s", this->objectName);
-  printf("%d:", this->mode);
   if(this->mode & PNODE_MOVEMENT )
     {
Index: /orxonox/trunk/src/track_manager.cc
===================================================================
--- /orxonox/trunk/src/track_manager.cc	(revision 3590)
+++ /orxonox/trunk/src/track_manager.cc	(revision 3591)
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_TRACKMANAGER
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_TRACK_MANAGER
 
 #include "track_manager.h"
@@ -672,5 +672,5 @@
 {
   dt /= 1000;
-  printf("CurrentTrackID: %d, LocalTime is: %f, timestep is: %f\n", this->currentTrackElem->ID, this->localTime, dt);
+  PRINTF(4)("CurrentTrackID: %d, LocalTime is: %f, timestep is: %f\n", this->currentTrackElem->ID, this->localTime, dt);
   if (this->localTime <= this->firstTrackElem->duration)
     this->jumpTo(this->localTime);