Index: orxonox/trunk/src/lib/math/curve.cc
===================================================================
--- orxonox/trunk/src/lib/math/curve.cc	(revision 3592)
+++ orxonox/trunk/src/lib/math/curve.cc	(revision 3593)
@@ -19,6 +19,9 @@
      local-Time implementation
      NURBS
+     tList implementation
      
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_MATH
 
 #include "curve.h"
Index: orxonox/trunk/src/proto_class.cc
===================================================================
--- orxonox/trunk/src/proto_class.cc	(revision 3592)
+++ orxonox/trunk/src/proto_class.cc	(revision 3593)
@@ -16,4 +16,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
 
 #include "proto_class.h"
Index: orxonox/trunk/src/track_manager.cc
===================================================================
--- orxonox/trunk/src/track_manager.cc	(revision 3592)
+++ orxonox/trunk/src/track_manager.cc	(revision 3593)
@@ -140,4 +140,42 @@
 }
 
+/**
+   \brief prints out debug information about this TrackElement
+*/
+void TrackElement::debug(void)
+{
+  PRINT(0)("--== TrackElement:%i ==--", this->ID);
+  if(this->getName())
+    PRINT(0)("Name: %s::", this->getName());
+  if(this->isFresh)
+    PRINT(0)("  -- has not jet eddited in any way --\n");
+  PRINT(0)("\n   TimeTable: startingTime=%f; endTime=%f; duration=%f; jumpTime=%f\n", this->startingTime, this->endTime, this->duration, this->jumpTime);
+  PRINT(0)("   consists of %d Points\n", this->nodeCount);
+  if (this->childCount == 0)
+    PRINT(0)("   has no child\n");
+  else if (this->childCount == 1)
+    PRINT(0)("   has 1 child: =%d=\n", this->children[0]->ID);
+  else if (this->childCount > 1)
+    {
+      PRINT(0)("   has %d children: ", this->childCount);
+      for(int i = 0; i < this->childCount; i++)
+	PRINT(0)("=%d= ", this->children[i]->ID);
+      PRINT(0)("\n");
+    }
+  
+  if(this->isHotPoint)
+    PRINT(0)("   is a special Point:\n");
+  if(this->isSavePoint)
+    PRINT(0)("    is a SavePoint\n");
+  if(this->isFork)
+    {
+      PRINT(0)("    is A Fork with with %d children.\n", this->childCount);
+    }
+  if(this->isJoined)
+    PRINT(0)("   is Joined at the End\n");
+  
+  if(!this->backLoopCheck(this)) /* this should not happen */
+    PRINT(2)(" THERE IS A BACKLOOP TO THIS ELEMENT\n");
+}
 
 /**
@@ -218,8 +256,7 @@
 	}
     }
-  PRINTF(3)("PathDecision with nearest algorithm: %d\n", nodeNumber);
+  PRINTF(4)("PathDecision with nearest algorithm: %d\n", nodeNumber);
   return nodeNumber;
 }
-
 
 
@@ -785,36 +822,5 @@
 	{
 	  TrackElement* tmpElem = this->findTrackElementByID(i);
-	  PRINT(0)("--== TrackElement:%i ==--", tmpElem->ID);
-	  if(tmpElem->getName())
-	    PRINT(0)("Name: %s::", tmpElem->getName());
-	  if(tmpElem->isFresh)
-	    PRINT(0)("  -- has not jet eddited in any way --\n");
-	  PRINT(0)("\n   TimeTable: startingTime=%f; endTime=%f; duration=%f; jumpTime=%f\n", tmpElem->startingTime, tmpElem->endTime, tmpElem->duration, tmpElem->jumpTime);
-	  PRINT(0)("   consists of %d Points\n", tmpElem->nodeCount);
-	  if (tmpElem->childCount == 0)
-	    PRINT(0)("   has no child\n");
-	  else if (tmpElem->childCount == 1)
-	    PRINT(0)("   has 1 child: =%d=\n", tmpElem->children[0]->ID);
-	  else if (tmpElem->childCount > 1)
-	    {
-	      PRINT(0)("   has %d children: ", tmpElem->childCount);
-	      for(int i = 0; i < tmpElem->childCount; i++)
-		PRINT(0)("=%d= ", tmpElem->children[i]->ID);
-	      PRINT(0)("\n");
-	    }
-
-	  if(tmpElem->isHotPoint)
-	    PRINT(0)("   is a special Point:\n");
-	  if(tmpElem->isSavePoint)
-	    PRINT(0)("    is a SavePoint\n");
-	  if(tmpElem->isFork)
-	    {
-	      PRINT(0)("    is A Fork with with %d children.\n", tmpElem->childCount);
-	    }
-	  if(tmpElem->isJoined)
-	    PRINT(0)("   is Joined at the End\n");
-
-	  if(!tmpElem->backLoopCheck(tmpElem)) /* this should not happen */
-	    PRINT(2)(" THERE IS A BACKLOOP TO THIS ELEMENT\n");
+	  tmpElem->debug();
 	}
     }
Index: orxonox/trunk/src/track_manager.h
===================================================================
--- orxonox/trunk/src/track_manager.h	(revision 3592)
+++ orxonox/trunk/src/track_manager.h	(revision 3593)
@@ -60,4 +60,6 @@
   // runtime
   TrackElement* history;     //!< a pointer to the last TrackElement we were on. This is if you want to walk the path backwards again.
+
+  void debug(void);
 
   // CONDITION FUNCTIONS and STUFF