Index: /orxonox/trunk/src/Makefile.am
===================================================================
--- /orxonox/trunk/src/Makefile.am	(revision 3607)
+++ /orxonox/trunk/src/Makefile.am	(revision 3608)
@@ -98,4 +98,5 @@
 		 defs/stdincl.h \
 		 defs/glincl.h \
+		 defs/comincl.h \
 		 defs/error.h \
 		 defs/debug.h \
Index: /orxonox/trunk/src/Makefile.in
===================================================================
--- /orxonox/trunk/src/Makefile.in	(revision 3607)
+++ /orxonox/trunk/src/Makefile.in	(revision 3608)
@@ -299,4 +299,5 @@
 		 defs/stdincl.h \
 		 defs/glincl.h \
+		 defs/comincl.h \
 		 defs/error.h \
 		 defs/debug.h \
Index: /orxonox/trunk/src/camera.cc
===================================================================
--- /orxonox/trunk/src/camera.cc	(revision 3607)
+++ /orxonox/trunk/src/camera.cc	(revision 3608)
@@ -17,6 +17,8 @@
 
 #include "camera.h"
+
 #include "world.h"
 #include "world_entity.h"
+#include "vector.h"
 
 using namespace std;
Index: /orxonox/trunk/src/camera.h
===================================================================
--- /orxonox/trunk/src/camera.h	(revision 3607)
+++ /orxonox/trunk/src/camera.h	(revision 3608)
@@ -38,5 +38,5 @@
   float deltaTime;
   float t;
-  Vector r;
+  Vector* r;
   float rAbs;
   float ka;
Index: /orxonox/trunk/src/command_node.cc
===================================================================
--- /orxonox/trunk/src/command_node.cc	(revision 3607)
+++ /orxonox/trunk/src/command_node.cc	(revision 3608)
@@ -22,4 +22,6 @@
 #include "game_loader.h"
 #include "world.h"
+#include "list.h"
+#include "orxonox.h"
 
 #include <stdio.h>
Index: /orxonox/trunk/src/command_node.h
===================================================================
--- /orxonox/trunk/src/command_node.h	(revision 3607)
+++ /orxonox/trunk/src/command_node.h	(revision 3608)
@@ -9,6 +9,8 @@
 #define _COMMAND_NODE_H
 
-#include "stdincl.h"
 
+#include "comincl.h"
+
+template<class T> class tList;
 class WorldEntity;
 class World;
Index: /orxonox/trunk/src/defs/comincl.h
===================================================================
--- /orxonox/trunk/src/defs/comincl.h	(revision 3608)
+++ /orxonox/trunk/src/defs/comincl.h	(revision 3608)
@@ -0,0 +1,13 @@
+/*!
+  \file glincl.h
+  \brief This file includes gl Headers.
+  
+  no Class is defined here, but the opengl Headers
+*/
+
+#ifndef _COMINCL_H
+#define _COMINCL_H
+
+#include "message_structures.h"
+
+#endif /* _COMINCL_H */
Index: /orxonox/trunk/src/defs/stdincl.h
===================================================================
--- /orxonox/trunk/src/defs/stdincl.h	(revision 3607)
+++ /orxonox/trunk/src/defs/stdincl.h	(revision 3608)
@@ -8,7 +8,4 @@
 #ifndef _STDINCL_H
 #define _STDINCL_H
-
-#define null 0   //!< null
-
 
 typedef unsigned char byte;
@@ -29,15 +26,4 @@
 #include "glincl.h"
 
-
-// MATH //
-#include "vector.h"
-
-#include "list.h"
-#include "list_template.h"
-#include "message_structures.h"
-#include "orxonox.h"
-#include "data_tank.h"
-#include "base_object.h"
-
 #include "error.h"
 #include "debug.h"
Index: /orxonox/trunk/src/game_loader.h
===================================================================
--- /orxonox/trunk/src/game_loader.h	(revision 3607)
+++ /orxonox/trunk/src/game_loader.h	(revision 3608)
@@ -2,6 +2,7 @@
 #define _GAME_LOADER_H
 
-#include "stdincl.h"
+//#include "stdincl.h"
 #include "story_def.h"
+#include "comincl.h"
 
 //-----------------------------------------------------------------------------
@@ -12,5 +13,4 @@
 class Camera;
 class CammandNode;
-
 
 class GameLoader 
Index: /orxonox/trunk/src/lib/coord/null_parent.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3607)
+++ /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3608)
@@ -20,4 +20,6 @@
 #include "null_parent.h"
 #include "stdincl.h"
+#include "vector.h"
+#include "list.h"
 
 
Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3607)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3608)
@@ -23,5 +23,11 @@
 #include "stdincl.h"
 
+#include "error.h"
+#include "debug.h"
+#include "list.h"
+#include "vector.h"
 #include "null_parent.h"
+
+
 //#include "vector.h"
 //#include "quaternion.h"
@@ -479,4 +485,5 @@
       if( this->bRelDirChanged || this->bAbsDirChanged)
 	pn->parentDirChanged ();
+
       pn->update();
       pn = this->children->nextElement();
Index: /orxonox/trunk/src/lib/coord/p_node.h
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.h	(revision 3607)
+++ /orxonox/trunk/src/lib/coord/p_node.h	(revision 3608)
@@ -23,5 +23,5 @@
 
 #include "base_object.h"
-#include "vector.h"
+//#include "vector.h"
 
 // FORWARD DEFINITION \\
Index: /orxonox/trunk/src/lib/graphics/light.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/light.cc	(revision 3607)
+++ /orxonox/trunk/src/lib/graphics/light.cc	(revision 3608)
@@ -21,4 +21,5 @@
 
 #include "glincl.h"
+#include "vector.h"
 
 using namespace std;
Index: /orxonox/trunk/src/message_structures.h
===================================================================
--- /orxonox/trunk/src/message_structures.h	(revision 3607)
+++ /orxonox/trunk/src/message_structures.h	(revision 3608)
@@ -6,4 +6,6 @@
 #ifndef _MESSAGE_STRUCTURES_H
 #define _MESSAGE_STRUCTURES_H
+
+#include "stdincl.h"
 
 #define CMD_LENGHT 16
Index: /orxonox/trunk/src/orxonox.h
===================================================================
--- /orxonox/trunk/src/orxonox.h	(revision 3607)
+++ /orxonox/trunk/src/orxonox.h	(revision 3608)
@@ -7,5 +7,6 @@
 #define _ORXONOX_H
 
-#include "stdincl.h"
+#include "comincl.h"
+#include "glincl.h"
 
 class CommandNode;
Index: /orxonox/trunk/src/story_entities/campaign.cc
===================================================================
--- /orxonox/trunk/src/story_entities/campaign.cc	(revision 3607)
+++ /orxonox/trunk/src/story_entities/campaign.cc	(revision 3608)
@@ -20,5 +20,6 @@
 #include "world.h"
 #include "camera.h"
-#include "story_entity.h"
+//#include "story_entity.h"
+#include "list.h"
 
 using namespace std;
@@ -27,5 +28,5 @@
 Campaign::Campaign () 
 {
-  this->entities = new ListTemplate<StoryEntity>();
+  this->entities = new tList<StoryEntity>();
   this->isInit = false;
 }
@@ -184,5 +185,7 @@
   if( storyID == WORLD_ID_GAMEEND)
     return NULL;
-  ListTemplate<StoryEntity>* l;
+
+  /*
+  tList<StoryEntity>* l;
   StoryEntity* entity = NULL;
   l = this->entities->getNext();  
@@ -191,4 +194,5 @@
       entity = l->getObject();
       l = l->getNext();
+
       int id = entity->getStoryID();
       //printf("Campaing::getStoryEntity() - now looping, found entity nr=%i\n", id);
@@ -198,5 +202,25 @@
 	  return entity;
 	}
-    }
+
+    }
+  */
+
+
+
+  StoryEntity* entity = this->entities->enumerate();
+  while( entity != NULL) 
+    { 
+      int id = entity->getStoryID();
+      //printf("Campaing::getStoryEntity() - now looping, found entity nr=%i\n", id);
+      if(id == storyID)
+	{
+	  //printf("Campaing::getStoryEntity() - yea, this is what we where looking for: %id\n");
+	  return entity;
+	}
+      entity = this->entities->nextElement();
+    }
+
+
+
   return NULL;
 }
Index: /orxonox/trunk/src/story_entities/campaign.h
===================================================================
--- /orxonox/trunk/src/story_entities/campaign.h	(revision 3607)
+++ /orxonox/trunk/src/story_entities/campaign.h	(revision 3608)
@@ -8,4 +8,5 @@
 
 class World;
+template<class T> class tList;
 
 class Campaign : public StoryEntity {
@@ -34,5 +35,6 @@
 
  private:
-  ListTemplate<StoryEntity>* entities;
+  //ListTemplate<StoryEntity>* entities;
+  tList<StoryEntity>* entities;
   bool running;
 
Index: /orxonox/trunk/src/story_entities/story_entity.h
===================================================================
--- /orxonox/trunk/src/story_entities/story_entity.h	(revision 3607)
+++ /orxonox/trunk/src/story_entities/story_entity.h	(revision 3608)
@@ -8,6 +8,8 @@
 #define _STORY_ENTITY_H
 
-#include "stdincl.h"
+#include "base_object.h"
 #include "story_def.h"
+#include "error.h"
+
 
 //! A class that represents something to play in orxonox. it is a container for worlds, movies, mission briefings, etc...
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3607)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3608)
@@ -18,20 +18,25 @@
 
 #include "world.h"
+
+#include "orxonox.h"
+#include "p_node.h"
+#include "null_parent.h"
+#include "helper_parent.h"
+#include "track_node.h"
 #include "world_entity.h"
 #include "track_manager.h"
 #include "player.h"
-#include "command_node.h"
 #include "camera.h"
 #include "environment.h"
 #include "primitive.h"
-#include "p_node.h"
-#include "null_parent.h"
-#include "helper_parent.h"
+#include "skysphere.h"
+#include "terrain.h"
+#include "light.h"
+#include "command_node.h"
 #include "glmenu_imagescreen.h"
-#include "skysphere.h"
-#include "light.h"
 #include "fontset.h"
-#include "track_node.h"
-#include "terrain.h"
+#include "list.h"
+
+
 
 using namespace std;
Index: /orxonox/trunk/src/story_entities/world.h
===================================================================
--- /orxonox/trunk/src/story_entities/world.h	(revision 3607)
+++ /orxonox/trunk/src/story_entities/world.h	(revision 3608)
@@ -8,4 +8,5 @@
 
 #include "stdincl.h"
+#include "comincl.h"
 #include "story_entity.h"
 #include "p_node.h"
Index: /orxonox/trunk/src/track_manager.cc
===================================================================
--- /orxonox/trunk/src/track_manager.cc	(revision 3607)
+++ /orxonox/trunk/src/track_manager.cc	(revision 3608)
@@ -18,7 +18,11 @@
 #include "track_manager.h"
 
+#include "base_object.h"
 #include "p_node.h"
-
 #include "track_node.h"
+#include "stdincl.h"
+#include "list.h"
+
+
 
 #include <stdarg.h>
Index: /orxonox/trunk/src/track_manager.h
===================================================================
--- /orxonox/trunk/src/track_manager.h	(revision 3607)
+++ /orxonox/trunk/src/track_manager.h	(revision 3608)
@@ -12,8 +12,9 @@
 #define _TRACK_MANAGER_H
 
-#include "stdincl.h"
 #include "curve.h"
+#include "base_object.h"
 
 class PNode;
+template<class T> class tList;
 
 // Static Definitions
Index: /orxonox/trunk/src/world_entities/player.cc
===================================================================
--- /orxonox/trunk/src/world_entities/player.cc	(revision 3607)
+++ /orxonox/trunk/src/world_entities/player.cc	(revision 3608)
@@ -40,5 +40,5 @@
 
   travelSpeed = 15.0;
-  velocity = Vector();
+  velocity = new Vector();
   bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
   bFire = false;
Index: /orxonox/trunk/src/world_entities/player.h
===================================================================
--- /orxonox/trunk/src/world_entities/player.h	(revision 3607)
+++ /orxonox/trunk/src/world_entities/player.h	(revision 3608)
@@ -12,4 +12,5 @@
 class OBJModel;
 class Weapon;
+class Vector;
 
 //! Basic controllable WorldEntity
@@ -48,5 +49,5 @@
   Weapon* activeWeapon;  //!< the weapon that is currenty activated
 
-  Vector velocity;       //!< the velocity of the player.
+  Vector* velocity;       //!< the velocity of the player.
   float travelSpeed;     //!< the current speed of the player (to make soft movement)
   float acceleration;    //!< the acceleration of the player.
Index: /orxonox/trunk/src/world_entities/primitive.cc
===================================================================
--- /orxonox/trunk/src/world_entities/primitive.cc	(revision 3607)
+++ /orxonox/trunk/src/world_entities/primitive.cc	(revision 3608)
@@ -18,7 +18,9 @@
 
 #include "primitive.h"
+
 #include "stdincl.h"
 #include "world_entity.h"
 #include "objModel.h"
+#include "vector.h"
 
 using namespace std;
Index: /orxonox/trunk/src/world_entities/primitive.h
===================================================================
--- /orxonox/trunk/src/world_entities/primitive.h	(revision 3607)
+++ /orxonox/trunk/src/world_entities/primitive.h	(revision 3608)
@@ -3,6 +3,10 @@
 
 #include "world_entity.h"
+#include "glincl.h"
 
 typedef enum PRIMITIVE_FORM {PSPHERE = 0, PCUBE, PSQUARE};
+
+class Material;
+
 
 class Primitive : public WorldEntity 
Index: /orxonox/trunk/src/world_entities/skysphere.cc
===================================================================
--- /orxonox/trunk/src/world_entities/skysphere.cc	(revision 3607)
+++ /orxonox/trunk/src/world_entities/skysphere.cc	(revision 3608)
@@ -26,9 +26,12 @@
 #define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
 
-#include "material.h"
+
 #include "skysphere.h"
 #include "stdincl.h"
+
+#include "material.h"
 #include "vector.h"
-#include "world_entity.h"
+//#include "world_entity.h"
+
 
 using namespace std;
Index: /orxonox/trunk/src/world_entities/skysphere.h
===================================================================
--- /orxonox/trunk/src/world_entities/skysphere.h	(revision 3607)
+++ /orxonox/trunk/src/world_entities/skysphere.h	(revision 3608)
@@ -14,5 +14,4 @@
 
 /* INCLUDES */
-#include "p_node.h"
 #include "world_entity.h"
 
Index: /orxonox/trunk/src/world_entities/terrain.cc
===================================================================
--- /orxonox/trunk/src/world_entities/terrain.cc	(revision 3607)
+++ /orxonox/trunk/src/world_entities/terrain.cc	(revision 3608)
@@ -16,5 +16,7 @@
 
 #include "terrain.h"
-
+#include "stdincl.h"
+#include "objModel.h"
+#include "vector.h"
 #include "glincl.h"
 
Index: /orxonox/trunk/src/world_entities/world_entity.cc
===================================================================
--- /orxonox/trunk/src/world_entities/world_entity.cc	(revision 3607)
+++ /orxonox/trunk/src/world_entities/world_entity.cc	(revision 3608)
@@ -19,5 +19,8 @@
 
 #include "world_entity.h"
-#include "stdincl.h"
+#include "objModel.h"
+#include "list.h"
+
+//#include "stdincl.h"
 //#include "collision.h"
 
Index: /orxonox/trunk/src/world_entities/world_entity.h
===================================================================
--- /orxonox/trunk/src/world_entities/world_entity.h	(revision 3607)
+++ /orxonox/trunk/src/world_entities/world_entity.h	(revision 3608)
@@ -7,10 +7,10 @@
 #define _WORLD_ENTITY_H
 
-#include "stdincl.h"
 #include "p_node.h"
-#include "objModel.h"
+#include "comincl.h"
 
 //class CollisionCluster;
 class CharacterAttributes;
+class OBJModel;
 
 